#include <avr/io.h>
#include <util/delay.h>
#include<stdlib.h>
#include<time.h>
 
int main() {
    //Setare pini de iesire  
    DDRA = 0xFF;
    DDRB = 0xFF;
    DDRD = (1 << PD2) | (1 << PD4); 

    //Setare pini de intrare
    DDRC &= (1 << PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4);
    PORTC |= (1 << PC0) | (1 << PC1) | (1 << PC2) | (1 << PC4);
    DDRD &= (1 << PD0) | (1 << PD1) | (1 << PD5) | (1 << PD6) | (1 << PD3) ;
    PORTD |= (1 << PD0) | (1 << PD1) | (1 << PD5) | (1 << PD6) | (1 << PD3);

    PORTA = (1 << PA0);
    _delay_ms(1000);

    PORTA = (1 << PA2);
    PORTA &= ~(1 << PA0);
    _delay_ms(1000);

    PORTA = (1 << PA4);
    PORTA &= ~(1 << PA2);
    _delay_ms(1000);

    PORTA = (1 << PA6);
    PORTA &= ~(1 << PC4);
    _delay_ms(1000);

    PORTB = (1 << PB0);
    PORTA &= ~(1 << PA6);
    _delay_ms(1000);

    PORTB = (1 << PB3);
    PORTB &= ~(1 << PB0);
    _delay_ms(1000);

    PORTD = (1 << PD4);
    PORTB &= ~(1 << PB3);
    _delay_ms(1000);

    PORTB = (1 << PB7);
    PORTD &= ~(1 << PD4);
    _delay_ms(1000);

    PORTB = (1 << PB4);
    PORTB &= ~(1 << PB7);
    _delay_ms(1000);
    PORTB &= ~(1 << PB4);
    

    srand(time(NULL));
	while(1) {
        int number = rand() % 9;
        int led = 0;
        PORTA = 0x00;
        PORTB = 0x00;
        PORTD = 0x00;

        if (number == 0)
            led = PA0;
        else if (number == 1)
            led = PA2;
        else if (number == 2)
            led = PA4;
        else if (number == 3)
            led = PA6;
        else if (number == 4)
            led = PB0;
        else if (number == 5)
            led = PB3;
        else if (number == 6)
            led = PB4;
        else if (number == 7)
            led = PB7;
        else 
            led = PD4;

        if (number < 4) {
            PORTA = (1 << led);
            PORTB = 0x00;
            PORTD = 0x00;
        }
        else if (number >= 4 && number < 8) {
            PORTB = (1 << led);
            PORTA = 0x00;
            PORTC = 0x00;
        }
        else {
            PORTD = (1 << led);
            PORTA = 0x00;
            PORTB = 0x00;
        }

        long seconds = 499999;
        while (seconds > 0) {
            if ((led == PA0) && ((PINC & (1 << PC0)) == 0)) {
                PORTA = (1 << PA1);
                PORTB = 0x00;
                PORTD = 0x00;
                break;
            }
            if ((led == PA2) && ((PINC & (1 << PC1)) == 0)) {
                PORTA = (1 << PA3);
                PORTB = 0x00;
                PORTD = 0x00;
                break;
            }
            if ((led == PA4) && ((PINC & (1 << PC2)) == 0)) {
                PORTA = (1 << PA5);
                PORTB = 0x00;
                PORTD = 0x00;
                break;
            }
            if ((led == PA6) && ((PIND & (1 << PD1)) == 0)) {
                PORTA = (1 << PA7);
                PORTB = 0x00;
                PORTD = 0x00;
                break;
            }
            if ((led == PB0) && ((PIND & (1 << PD0)) == 0)) {
                PORTB = (1 << PB1);
                PORTA = 0x00;
                PORTD = 0x00;
                break;
            }
            if ((led == PB3) && ((PINC & (1 << PC4)) == 0)) {
                PORTB = (1 << PB2);
                PORTA = 0x00;
                PORTD = 0x00;
                break;
            }
            if ((led == PD4) && ((PIND & (1 << PD6)) == 0)) {
                PORTD = (1 << PD2);
                PORTA = 0x00;
                PORTB = 0x00;
                break;
            }
            if ((led == PB6) && ((PIND & (1 << PD5)) == 0)) {
                PORTB = (1 << PB7);
                PORTA = 0x00;
                PORTD = 0x00;
                break;
            }
            if ((led == PB4) && ((PIND & (1 << PD3)) == 0)) {
                PORTB = (1 << PB5);
                PORTA = 0x00;
                PORTD = 0x00;
                break;
            }

            seconds--;
        }

        _delay_ms(1000);
	}
 
	return 0;
}


